
Ruby - Bug #10496

Yaml: Serialization of cross-referrenced objects with psych

11/11/2014 10:29 PM - jonnykh (Ivan Neverov)

Status: Closed   

Priority: Normal   

Assignee: tenderlovemaking (Aaron Patterson)   

Target version:    

ruby -v: 2.1.3p242, 1.9.3p550 Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:

UNKNOWN

Description

I'm trying to run next code that serialize object B that has instance variable of A initialized with this B (cross referenced). After

deserialization I'm getting 2 B objects instead of 1

https://gist.github.com/ineverov/3ce3ea21d970996b673e

During investigation of source code of psych I found that we don't register objects that use encode_with methods

Here: https://github.com/ruby/ruby/blob/trunk/ext/psych/lib/psych/visitors/yaml_tree.rb#L530

Associated revisions

Revision ecbf8351808c2425ec081c9055c9ddd790933e8b - 02/06/2015 08:50 AM - tenderlovemaking (Aaron Patterson)

ext/psych/lib/psych/visitors/yaml_tree.rb: register nodes when

dumping objects with custom coders. [ruby-core:66215] [Bug #10496]

test/psych/test_coder.rb: test for fix

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49529 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ecbf8351 - 02/06/2015 08:50 AM - tenderlovemaking (Aaron Patterson)

ext/psych/lib/psych/visitors/yaml_tree.rb: register nodes when

dumping objects with custom coders. [ruby-core:66215] [Bug #10496]

test/psych/test_coder.rb: test for fix

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@49529 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/31/2014 06:27 AM - duerst (Martin Dürst)

- Assignee changed from core to tenderlovemaking (Aaron Patterson)

#2 - 02/06/2015 08:50 AM - Anonymous

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset r49529.

ext/psych/lib/psych/visitors/yaml_tree.rb: register nodes when

dumping objects with custom coders. [ruby-core:66215] [Bug #10496]

test/psych/test_coder.rb: test for fix
#3 - 02/17/2015 02:31 PM - wanabe (_ wanabe)

- Backport set to 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN
